<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): /home/mohamed/code/tigl/src/standard/utils/tiglUtilsRemoveSelfCycles.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_bc49a3b403b59ab508217f3692053f91.html">standard</a></li><li class="navelem"><a class="el" href="dir_dbc0cc34dc50d9fa937ca50c591705e8.html">utils</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglUtilsRemoveSelfCycles.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglUtilsRemoveSelfCycles_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef TIGLUTILSREMOVESELFCYCLES_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define TIGLUTILSREMOVESELFCYCLES_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="tiglUtilsRemoveSelfCycles_8hpp.html#a8e6c486342f87f5707bc85e562880b4e">   16</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="tiglUtilsRemoveSelfCycles_8hpp.html#a8e6c486342f87f5707bc85e562880b4e">tiglGenerationRemoveSelfCycles</a>(vector&lt;CVertex&gt; &amp; verticesList)</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;{</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE <a class="code" href="classEdgeBase.html">EDGE_TYPE</a>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;   <span class="keyword">typename</span> vector&lt;CVertex&gt;::iterator itv = verticesList.begin();</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;   <span class="keywordtype">bool</span> isBivertex = itv-&gt;isBiVertex();</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;   <span class="keywordflow">for</span> (; itv != verticesList.end(); ++itv) <span class="comment">/*itv already initialized*/</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;   {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;      ID_TYPE vertexId = itv-&gt;getId();</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      <span class="keywordflow">for</span> (<span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR ite =</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            itv-&gt;getBeginOutEdgeIterator(); ite != itv-&gt;getEndOutEdgeIterator();</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            ++ite) { <span class="comment">/*loop for checking the target*/</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;         <span class="keywordflow">if</span> (ite-&gt;getNbr() == vertexId) {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            <span class="keywordflow">if</span> (isBivertex) <span class="comment">/*removing link to the input*/</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;               itv-&gt;removeInEdge(vertexId);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            itv-&gt;removeEdge(vertexId);<span class="comment">/*removing the edge itself from output edges*/</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            <span class="keywordflow">break</span>; <span class="comment">/* no more search at the current vertex is needed if a self-cycle is found*/</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;         }</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;      }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;   }</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLUTILSREMOVESELFCYCLES_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classEdgeBase_html"><div class="ttname"><a href="classEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">core edge class </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:31</div></div>
<div class="ttc" id="tiglUtilsRemoveSelfCycles_8hpp_html_a8e6c486342f87f5707bc85e562880b4e"><div class="ttname"><a href="tiglUtilsRemoveSelfCycles_8hpp.html#a8e6c486342f87f5707bc85e562880b4e">tiglGenerationRemoveSelfCycles</a></div><div class="ttdeci">void tiglGenerationRemoveSelfCycles(vector&lt; CVertex &gt; &amp;verticesList)</div><div class="ttdef"><b>Definition:</b> tiglUtilsRemoveSelfCycles.hpp:16</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Jan 20 2015 16:21:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
